import { InjectionToken } from '@angular/core';
import { TransferState } from '@angular/platform-browser';
import { HttpHeaders, HttpParams, HttpClient } from '@angular/common/http';
import { HttpSetting } from './http.setting';
import { Observable } from 'rxjs';
export declare const HTTP_SETTING: InjectionToken<HttpSetting>;
export declare class SinusHttpService {
    protected transferState: TransferState;
    private httpClient;
    private setting;
    private platformId;
    private baseApiUrl;
    private baseFilesUrl;
    constructor(transferState: TransferState, httpClient: HttpClient, setting: HttpSetting, platformId: Object);
    setToken(token: string): void;
    getToken(): string;
    get<T>(url: string, options?: IRequestOptions, force?: boolean): Observable<T>;
    getData<T>(url: string, options?: IRequestOptions, force?: boolean): Observable<T>;
    pureGet<T>(url: string, options?: IRequestOptions, force?: boolean): Observable<T>;
    post<T>(url: string, body: any, options?: IRequestOptions, force?: boolean): Observable<T>;
    purePost<T>(url: string, body: any, options?: IRequestOptions, force?: boolean): Observable<T>;
    put<T>(url: string, body: any, options?: IRequestOptions, force?: boolean): Observable<T>;
    purePut<T>(url: string, body: any, options?: IRequestOptions, force?: boolean): Observable<T>;
    delete<T>(url: string, options?: IRequestOptions, force?: boolean): Observable<T>;
    pureDelete<T>(url: string, options?: IRequestOptions, force?: boolean): Observable<T>;
    getUrl(url: string): string;
    getFileUrl(section: string, file: string): string;
    private prepareData(method, url, options, body, force, cb);
    private resolveData(key, method, force?);
    private setCache(key, data);
    private getFromCache(key);
}
export interface IRequestOptions {
    headers?: HttpHeaders;
    observe?: 'body';
    params?: HttpParams;
    reportProgress?: boolean;
    responseType?: 'json';
    withCredentials?: boolean;
}
export interface IResolveCallback {
    url: string;
    options: any;
    body?: any;
}
